#define LF              0x0a
#define CR              0x0d
#define XON             0x11
#define XOFF            0x13
#define ESC             0x1b
#define BLANK           0x20
#define TERMINATOR      CR              /* message terminator */
#define SEQUENCE_START  ESC             /* message start */

#ifndef SIO_MOD_DEFINED

#define SIO_MOD_DEFINED
#define SOFTFLOW        0
#define HARDFLOW        1

extern void sio_init(char soft_flow_control);
extern void sio_in_flush(void);
extern void sio_out_flush(void);
extern char _getkey(void);
extern char getchar(void);
extern char ungetchar(char);
extern void putchar(char character);

extern bit sio_inrdy(void);
extern bit sio_inrdy_to_pack(void);
extern char sio_message(void);
extern bit sio_outrdy(void);
extern bit sio_outempty(void);
extern unsigned int updcrc(unsigned char character, unsigned int oldcrc);

extern bit parity_err;      /* received character has a parity error */

/* stdio.h defines */

extern int printf (const char *, ...);
extern int sprintf (char *, const char *, ...);
extern char *gets (char *, int n);
extern int scanf (const char *, ...);
extern int sscanf (char *, const char *, ...);
extern int puts (const char *);

#else

#define AUTO_XON
#define RELAXED_XOFF
#define WATCHDOG        0               /* 0=without watchdog, 1=with watchdog */
#define CRC_CHECK       0               /* 0=without crc-check, 1=with crc-check */

#define SIO_INT         4
#define TIMER1_INT      3

#define TIMER1_TIME     -1000           /* 1 ms */
#define CHAR_DELAY      3               /* 3 ms */
#define IGNORE_XOFF     3000            /* 3000 ms */
#define GIVE_XON        2000            /* 2000 ms */

#define TX_BUF_LEN      40
#define RX_BUF_LEN      40

#define XON_LIMIT       (RX_BUF_LEN*60/100)
#define XOFF_LIMIT      (RX_BUF_LEN*80/100)

#endif
